/**
@authors: Frederic BERNARD AB/CO-IS
@date: 29/10/2008
@file unLHCCircuit_CRYO.ctl

*/

/**
* @name LHCCircuit Cryo
This is a set of functions provided to manage Cryo Data in LHCCircuit
* @{
*/

#uses "unNotify.ctl"

//------------------------------------------------------------------------------------------------------------------------
// CONST DEFINTION

const string SYSTEM_PATTERN="<system *";
const string CIRCUIT_PATTERN="*<circuit *";
const string INSTRUM_PATTERN="*<cryo_device *";
const string SYSTEM_PATTERN_END="</system>*";
const string CIRCUIT_PATTERN_END="*</circuit>*";

const string CRYO_SEPARATOR=";";

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_readXMLFile - OBSOLETE
*/

int unLHCCircuit_CRYO_readXMLFile(const string sFileName)
{
string sBuffer, sInstrum;
dyn_string dsSplit, dsLines;
int i, iLen, iRes, iSystem, iCircuit;
dyn_string dsCryoCircuits, dsCryoInterlockType, dsCryoCircuitType, dsCryoSubSector;

	iRes=access(sFileName, F_OK);
	if (iRes==0) // File exist
		{
	 	fileToString(sFileName, sBuffer);
		dsLines = strsplit(sBuffer, "\n");
		iLen = dynlen(dsLines);
		for (i=1;i<=iLen && iRes==0;i++)
			{
			if (patternMatch(SYSTEM_PATTERN, dsLines[i]))
				{
    		dsSplit=strsplit(dsLines[i], "\"");
		  	if (dynlen(dsSplit)==3)
			  	{                          
          iSystem++;
					dynAppend(g_dsCryoSystemName, dsSplit[2]);
          g_ddsCryoCircuits[iSystem]=makeDynString();
          g_ddsCryoInterlockType[iSystem]=makeDynString();
          g_ddsCryoCircuitType[iSystem]=makeDynString();
		g_ddsCryoSubSector[iSystem]=makeDynString();		  
          g_ddsCryoInstrum[iSystem]=makeDynString();
				}
			else
				iRes=-1;			
        }
			else if (patternMatch(CIRCUIT_PATTERN, dsLines[i]))
			  {
    		dsSplit=strsplit(dsLines[i], "\"");
		  	if (dynlen(dsSplit)==9)
          {
          iCircuit++;
          dsCryoCircuits=g_ddsCryoCircuits[iSystem];
          dsCryoInterlockType=g_ddsCryoInterlockType[iSystem];
          dsCryoCircuitType=g_ddsCryoCircuitType[iSystem];
		 dsCryoSubSector=g_ddsCryoSubSector[iSystem];		  
          dynAppend(dsCryoCircuits, dsSplit[2]);
          dynAppend(dsCryoInterlockType, dsSplit[4]);
          dynAppend(dsCryoCircuitType, dsSplit[6]);
          dynAppend(dsCryoSubSector, dsSplit[8]);
			g_ddsCryoSubSector[iSystem]=dsCryoSubSector;
			g_ddsCryoCircuits[iSystem]=dsCryoCircuits;
			g_ddsCryoInterlockType[iSystem]=dsCryoInterlockType;
			g_ddsCryoCircuitType[iSystem]=dsCryoCircuitType;
          g_ddsCryoInstrum[iSystem][iCircuit]="";                              
          }
		else
			iRes=-1;
        }
			else if (patternMatch(INSTRUM_PATTERN, dsLines[i]))
				{
    		dsSplit=strsplit(dsLines[i], "\"");
		  	if (dynlen(dsSplit)==3)
          {		  
          sInstrum=g_ddsCryoInstrum[iSystem][iCircuit]+ CRYO_SEPARATOR + dsSplit[2];
					g_ddsCryoInstrum[iSystem][iCircuit]=sInstrum;
					}
			else
				iRes=-1;					
        }
			else if (patternMatch(SYSTEM_PATTERN_END, dsLines[i]))
				{
  			iCircuit=0;
        }
			else if (patternMatch(CIRCUIT_PATTERN_END, dsLines[i]))
				{
        } 
			else
				{
				DebugN("Incorrect XML tag: " + dsLines[i]);
				iRes=-2;
        }
			}  //end for
		}
	else
		DebugN("unLHCCircuit_CRYO_readXMLFile() - File does not exist! - " + sFileName);
	
	return iRes;  
}

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_setCryoDomainNature - OBSOLETE
*/

int unLHCCircuit_CRYO_setCryoDomainNature(const string sSystemName)
{
int iSystem, iLenCircuit, iLen, jLen, kLenInstrum, i, k, m, iRes, iDomain, iNature;
string sCircuit, sInterlockType, sCircuitType, sInstrum, sDp, sOldDomain, sOldNature, sParameter, sSubSector; 
dyn_string dsInstrum, dsParameters, dsExceptionInfo, dsSplit;
bool bUpdateNature, bUpdateDomain;

  DebugTN("Start unLHCCircuit_CRYO_setCryoDomainNature(): " + sSystemName);

  iSystem=dynContains(g_dsCryoSystemName, sSystemName);
  iLen=dynlen(g_ddsCryoCircuits);
  jLen=dynlen(g_ddsCryoInstrum);
  if(iSystem>0 && iSystem<=iLen && iSystem<=jLen)
    {
    iLenCircuit=dynlen(g_ddsCryoCircuits[iSystem]);    
    for(i=1; i<=iLenCircuit; i++)
      {
      sCircuit=g_ddsCryoCircuits[iSystem][i];
      sInterlockType=g_ddsCryoInterlockType[iSystem][i];
      sCircuitType=g_ddsCryoCircuitType[iSystem][i];            
      sSubSector=g_ddsCryoSubSector[iSystem][i];
	  sInstrum=g_ddsCryoInstrum[iSystem][i];
      dsInstrum=strsplit(sInstrum, CRYO_SEPARATOR);
      dynUnique(dsInstrum);
      kLenInstrum=dynlen(dsInstrum);
      for(k=1; k<=kLenInstrum; k++)
        {
        sDp=unGenericDpFunctions_dpAliasToName(sSystemName+dsInstrum[k]);
        bUpdateNature=FALSE;
        bUpdateDomain=FALSE;		
        if(sDp!="")
          {
          unGenericDpFunctions_getParameters(sDp, dsParameters);
          sParameter=dsParameters[UN_PARAMETER_DOMAIN];
          sOldDomain=sParameter;
          dsSplit=strsplit(sParameter, ",");
          if(dynContains(dsSplit, sCircuit)==0)
            {
            dynAppend(dsSplit, sCircuit);
            sParameter="";
            for(m=1; m<=dynlen(dsSplit); m++)
              sParameter=sParameter+dsSplit[m]+",";
            
            sParameter=substr(sParameter, 0, strlen(sParameter)-1);
            dsParameters[UN_PARAMETER_DOMAIN]=sParameter;
            bUpdateDomain=TRUE;
            }

          sParameter=dsParameters[UN_PARAMETER_NATURE];
          sOldNature=sParameter;         
          dsSplit=strsplit(sParameter, ",");
          if(dynContains(dsSplit, sSubSector)==0)
            {
            dynAppend(dsSplit, sSubSector);
            sParameter="";
            for(m=1; m<=dynlen(dsSplit); m++)
              sParameter=sParameter+dsSplit[m]+",";
            
            sParameter=substr(sParameter, 0, strlen(sParameter)-1);
            dsParameters[UN_PARAMETER_NATURE]=sParameter;
            bUpdateNature=TRUE;
            }
			
          sParameter=dsParameters[UN_PARAMETER_NATURE];
          sOldNature=sParameter;         
          dsSplit=strsplit(sParameter, ",");
          if(dynContains(dsSplit, sInterlockType)==0)
            {
            dynAppend(dsSplit, sInterlockType);
            sParameter="";
            for(m=1; m<=dynlen(dsSplit); m++)
              sParameter=sParameter+dsSplit[m]+",";
            
            sParameter=substr(sParameter, 0, strlen(sParameter)-1);
            dsParameters[UN_PARAMETER_NATURE]=sParameter;
            bUpdateNature=TRUE;
            }

          sParameter=dsParameters[UN_PARAMETER_NATURE];
          dsSplit=strsplit(sParameter, ",");
          if(dynContains(dsSplit, sCircuitType)==0)
            {
            dynAppend(dsSplit, sCircuitType);
            sParameter="";
            for(m=1; m<=dynlen(dsSplit); m++)
              sParameter=sParameter+dsSplit[m]+",";
            
            sParameter=substr(sParameter, 0, strlen(sParameter)-1);
            dsParameters[UN_PARAMETER_NATURE]=sParameter;
            bUpdateNature=TRUE;
            }          
          
          if(bUpdateNature || bUpdateDomain)
            {
            dynClear(dsExceptionInfo);
            unGenericDpFunctions_setParameters(sDp, dsParameters, dsExceptionInfo);
            DebugN("---  " + sSystemName+dsInstrum[k] + "  ---");
            if(dynlen(dsExceptionInfo)>0)
              DebugN("Error with _setParameters!");
            else
              {
              if(bUpdateDomain) {iDomain++;DebugN("Old Domain: " + sOldDomain + " -> " + "new Domain: " + dsParameters[UN_PARAMETER_DOMAIN]);}
              if(bUpdateNature) {iNature++;DebugN("Old Nature: " + sOldNature + " -> " + "new Nature: " + dsParameters[UN_PARAMETER_NATURE]);}
              }
            }          
          }
        }  
      }
    }
  else
    DebugN("No Circuit info for SystemName: " + sSystemName);
  
  DebugTN("End unLHCCircuit_CRYO_setCryoDomainNature(): " + iDomain + " Domain updated - " + iNature + " Nature updated" + " - iRes=" + iRes);      
  return iRes;
}

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_getSubSystems - OBSOLETE
*/

int unLHCCircuit_CRYO_getSubSystems(const dyn_string dsNames, const int iLen, dyn_string &dsSubSystems, dyn_dyn_string &ddsDevicesSubSystems)
{
int iRes, i, jLen, kLen, iCL, iPos;
dyn_string dsSplit, dsTemp;
string sCL, sSubsystem, sName;

  for (i=1; i<=iLen; i++)
    {
    sName=substr(dsNames[i], strpos(dsNames[i],":")+1);
    dsSplit=strsplit(sName,"_");
    jLen=dynlen(dsSplit);
    if(jLen==3)
      {
      if(patternMatch("DFB*", sName))
        {  
        sSubsystem=dsSplit[1]+"."+dsSplit[2];
        //e.g: sSubsystem="DFBAB.07R1"
        }
      else
        {  
        sCL=dsSplit[1];
        kLen=strlen(sCL);
        sCL=substr(sCL, (kLen-2), 2);
        sscanf(sCL, "%d", iCL);
        sSubsystem=dsSplit[2]+"."+iCL;
        //e.g: sSubsystem="7R1.2"
        }
      
      iPos=dynContains(dsSubSystems, sSubsystem);
      if(iPos==0)
        {
        dynAppend(dsSubSystems, sSubsystem);
        iPos=dynlen(dsSubSystems);
        ddsDevicesSubSystems[iPos]=makeDynString();
        }
      
      dsTemp=ddsDevicesSubSystems[iPos];
      dynAppend(dsTemp, dsNames[i]);
      ddsDevicesSubSystems[iPos]=dsTemp;      
      }
    else
      iRes=-1;  
    }

//DebugN(dsSubSystems, ddsDevicesSubSystems);   
    
return iRes;
}

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_checDollarParameters - OBSOLETE
*/

int unLHCCircuit_CRYO_checDollarParameters(const string sCircuit, const string sInterlockType, const string sCircuitType, const int iLen)
{
int iRes, iNum;
  
  if(sInterlockType==CIRCUIT_A && sCircuitType=="MAINDIPOLE")      iNum=24;
  else if(sInterlockType==CIRCUIT_A && sCircuitType=="MAINQUAD")   iNum=11;
  else if(sInterlockType==CIRCUIT_A && sCircuitType=="IT")         iNum=18;    
  else if(sInterlockType==CIRCUIT_B1 && sCircuitType=="600AEE")    iNum=0;
  else if(sInterlockType==CIRCUIT_B1 && sCircuitType=="600ANOEE")  iNum=0;
  else if(sInterlockType==CIRCUIT_B1 && sCircuitType=="600ANOEECR")iNum=0;
  else if(sInterlockType==CIRCUIT_B1 && sCircuitType=="IPD")       iNum=11;
  else if(sInterlockType==CIRCUIT_B1 && sCircuitType=="80120A")    iNum=0;                
  else if(sInterlockType==CIRCUIT_B2 && sCircuitType=="IPQ")       iNum=15;
  else if(sInterlockType==CIRCUIT_C && sCircuitType=="80120A")     iNum=0;
  else if(sInterlockType==CIRCUIT_D && sCircuitType=="60A")        iNum=1;   
  else  {iRes=-1; DebugN("unLHCCircuit_CRYO_checDollarParameters() - Case not defined: " + sInterlockType + " - " + sCircuitType);}
  
  if(iRes==0)
    {
    if(iLen!=iNum)
      DebugN("unLHCCircuit_CRYO_checDollarParameters() - Wrong Number of Dollar Parameters(" + sCircuit + "  " + sInterlockType + "/" + sCircuitType + "): " + iLen + " - Need: " + iNum);
    }
  
return iRes;
}
  
//------------------------------------------------------------------------------------------------------------------------
/** CRYO_orderDevices
*/

int unLHCCircuit_CRYO_orderDevices(dyn_string &dsNames)
{
int iRes;

  iRes=dynSortAsc(dsNames);

return iRes;
}
  
//------------------------------------------------------------------------------------------------------------------------
/** CRYO_getInstrumSynopticDollarParameters
*/

int unLHCCircuit_CRYO_getInstrumSynopticDollarParameters(const string sInterlockType, const string sCircuitType, const string sCircuit, dyn_string dsTemp, const int iLen, dyn_string &dsCryo)
{
int iRes;
dyn_string dsSubSystems;
dyn_dyn_string ddsDevicesSubSystems;

  iRes=unLHCCircuit_CRYO_orderDevices(dsTemp);
  iRes=unLHCCircuit_CRYO_getSubSystems(dsTemp, iLen, dsSubSystems, ddsDevicesSubSystems);
  iRes=unLHCCircuit_CRYO_setDollarParams(dsSubSystems, ddsDevicesSubSystems, dsCryo);
     
return iRes;  
}     

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_getCryoSynopticDollarParameters
*/

int unLHCCircuit_CRYO_getCryoSynopticDollarParameters(const dyn_string dsTemp, const int iLen, string &sDollars)
{
int iRes, i;

  for(i=1; i<=iLen; i++)
    {
    if(patternMatch("*_CryoMaintain*", dsTemp[i])) sDollars=sDollars+"~"+"$CRYO_MAINTAIN:" + dsTemp[i];
    else if(patternMatch("*_CryoStart*", dsTemp[i])) sDollars=sDollars+"~"+"$CRYO_START:" + dsTemp[i];
    else if(patternMatch("*_PP60A", dsTemp[i])) sDollars=sDollars+"~"+"$CRYO_MAINTAIN_60A:" + dsTemp[i];    
    else iRes=-1;
    }
     
return iRes;  
}

//------------------------------------------------------------------------------------------------------------------------
/** CRYO_setDollarParams
*/

int unLHCCircuit_CRYO_setDollarParams(const dyn_string dsSubSystems, const dyn_dyn_string ddsDevicesSubSystems, string &sDollars)
{
int iRes, iLen, jLen, j, i, k, m;
string sDevice;
dyn_string dsSplit;

  iLen=dynlen(dsSubSystems);
  
  for(i=1; i<=iLen; i++)
    {
    if(patternMatch("DFB*", dsSubSystems[i]))
      {
      k++; 
      sDollars=sDollars+"~"+"$DFB_SS_" + k + ":" + dsSubSystems[i];
      }
    else
      {
      m++;  
      sDollars=sDollars+"~"+"$CL_SS_" + m + ":" + dsSubSystems[i];
      }
	  
    jLen=dynlen(ddsDevicesSubSystems[i]);
    for(j=1; j<=jLen; j++)
      {
      sDevice=substr(ddsDevicesSubSystems[i][j],strpos(ddsDevicesSubSystems[i][j],":")+1);
      dsSplit=strsplit(sDevice, "_");
      if(dynlen(dsSplit)==3)
        {
        if(patternMatch("DFB*", dsSubSystems[i]))
          sDollars=sDollars+"~"+"$CRYO_DFB_" + dsSplit[3] + "_" + k + ":" + ddsDevicesSubSystems[i][j];
        else
          sDollars=sDollars+"~"+"$CRYO_" + dsSplit[3] + "_" + m + ":" + ddsDevicesSubSystems[i][j];          
        }
      else
        {
		iRes=-1;
		DebugN("iRes: " + iRes, dsSplit, j);
		}
      }
    }
  
return iRes;  
}


//------------------------------------------------------------------------------------------------------------------------
/** unLHCCircuit_CRYO_getCryoPanel
*/

int unLHCCircuit_CRYO_getCryoPanel(const string sCircuit, const string sInterlockType, const string sCircuitType, const string sDollars, const string sDFB, string &sPanel, dyn_string &diXY)
{
int iRes, iLen, i;
bool bLT830, bLT830B, bCV2;
dyn_int diSize;
dyn_bool dbRes;
dyn_string dsSplit;
bool bCPC5;

  diXY[1]=0;
  diXY[2]=0;         

  if(sCircuit!="" && sInterlockType!="" && sCircuitType!="")
    {    
    dsSplit=strsplit(sDollars,"~");
	
	if(dynContains(dsSplit, "$CPC5:TRUE") > 0)
		bCPC5 = true;
    dbRes=patternMatch("*LT830", dsSplit);
    dynUnique(dbRes);
    iLen=dynlen(dbRes);
    bLT830=FALSE;
    for(i=1;i<=iLen && !bLT830;i++)
      if(dbRes[i])  bLT830=TRUE;
    
	if(!bLT830)
		{
		dbRes=patternMatch("*LT830B", dsSplit);
		dynUnique(dbRes);
		iLen=dynlen(dbRes);
		bLT830B=FALSE;
		for(i=1;i<=iLen && !bLT830B;i++)
			if(dbRes[i])  bLT830B=TRUE;
		}

    switch(sCircuitType)
      {
      case "MAINDIPOLE":
        sPanel="vision/SYNOPTICS/Synoptic_CRYO_A_MAINDIPOLE.pnl";
        diXY[1]=450;
        diXY[2]=350;
        break;
      
      case "MAINQUAD":
        sPanel="vision/SYNOPTICS/Synoptic_CRYO_A_MAINQUAD.pnl";
        diXY[1]=450;
        diXY[2]=350;        
        break;
            
      case "IT":
        sPanel="vision/SYNOPTICS/Synoptic_CRYO_A_MAINDIPOLE-IT.pnl";   
        diXY[1]=450;
        diXY[2]=350;              
        break;      
      
      case "IPQ":
        if(bLT830) sPanel="vision/SYNOPTICS/Synoptic_CRYO_B2_LT830.pnl";
        else sPanel="vision/SYNOPTICS/Synoptic_CRYO_B2_LT836.pnl";
        diXY[1]=452;
        diXY[2]=350;        
        break;      
      
      case "IPD":
        if(bLT830) sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-IPD_LT830.pnl";
        else if(sDFB=="DFBXD" || sDFB=="DFBXG" || sDFB=="DFBXC" || sDFB=="DFBXB" || sDFB=="DFBXE" || sDFB=="DFBXF" || sDFB=="DFBXH" || sDFB=="DFBXA") sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-IPD_LT830B.pnl";
        else sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-IPD_LT836.pnl";		
        diXY[1]=450;
        diXY[2]=350;        
        break;      
            
      case "80120A":
        if(patternMatch("RC*X*", sCircuit)) {
          if(bLT830B) {
			      dbRes=patternMatch("$CRYO_CV891_2*", dsSplit);
			      dynUnique(dbRes);
			      iLen=dynlen(dbRes);
			      bCV2=FALSE;
			      
			      for(i=1;i<=iLen && !bCV2;i++)
				      if(dbRes[i])  bCV2=TRUE;
				      
			      if(bCV2)
			        sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A-TRIPLET_LT830B_CV2.pnl";	//only one CV but on the second CL !!!
			      else
			        sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A-TRIPLET_LT830B.pnl";
			    }else
			      sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A-TRIPLET_LT836.pnl"; 
			      
          diXY[1]=460;
          diXY[2]=350;
        }else{
          if(bLT830)
            sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A_LT830.pnl";
          else
            sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A_LT836.pnl";
            
          diXY[1]=461;
          diXY[2]=350;          
        }
      break;      
      
      case "60A":
        sPanel="vision/SYNOPTICS/Synoptic_CRYO_D_60A.pnl";
        diXY[1]=461;
        diXY[2]=350;        
        break;      
      
      default:
        switch(sInterlockType)
          {
          case "B1":
            if(patternMatch("RCS.*", sCircuit))
              {
              if(bLT830) sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-RCS_LT830.pnl";
              else  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-RCS_LT836.pnl";
              diXY[1]=450;
              diXY[2]=350;
              }
            else if(patternMatch("RCBXH*", sCircuit) || patternMatch("RCBXV*", sCircuit) || patternMatch("RQSX*", sCircuit))
              {
              if(sDFB=="DFBXD" || sDFB=="DFBXG" || sDFB=="DFBXC" || sDFB=="DFBXB" || sDFB=="DFBXE" || sDFB=="DFBXF" || sDFB=="DFBXH" || sDFB=="DFBXA")  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-TRIPLET_LT830B.pnl";
              else sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-TRIPLET_LT836.pnl";           
              diXY[1]=450;
              diXY[2]=350;              
              }
            else if(patternMatch("RCBC*", sCircuit))
              {
              if(bLT830)  sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A_LT830.pnl";
              else sPanel="vision/SYNOPTICS/Synoptic_CRYO_C_120A_LT836.pnl";
              diXY[1]=452;
              diXY[2]=350;              
              }
            else if(patternMatch("RCO.*", sCircuit))
              {
              if(bLT830)  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-RCO_LT830.pnl";              
              else sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A-RCO_LT836.pnl";
              diXY[1]=452;
              diXY[2]=350;              
              }            
            else
              {                            
              if(bLT830)  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A_LT830.pnl";
              else if (sDFB == "DFBLC")  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A_LT836_PT833.pnl";
              else  sPanel="vision/SYNOPTICS/Synoptic_CRYO_B1_600A_LT836.pnl";                
              diXY[1]=452;
              diXY[2]=350;              
              }
            break;
        
          default:
            DebugN("unLHCCircuit_CRYO_getCryoPanel() - wrong Circuit definiton - Circuit: " + sCircuit + " - Interlock Type: " + sInterlockType + " - Circuit Type: " + sCircuitType + " - Circuit: " + sCircuit);
          }
      }
    }
  else
    DebugN("unLHCCircuit_CRYO_getCryoPanel() - Invalid entries - Circuit: " + sCircuit + " - Interlock Type: " + sInterlockType + " - Circuit Type: " + sCircuitType);

  // CPC5 - CPC6 CRYO panel
  if(bCPC5)
	strreplace(sPanel, "vision/SYNOPTICS/Synoptic_CRYO_", "vision/SYNOPTICS/CPC5_Synoptic_CRYO_");
      
  unGenericDpFunctions_debugN(DEBUG_ONLY_BIT0, "unLHCCircuit_CRYO_getCryoPanel: "+sCircuit, "unLHCCircuit_CRYO_getCryoPanel()", sCircuit, sInterlockType, sCircuitType, sPanel, sDollars); 
  //DebugN("unLHCCircuit_CRYO_getCryoPanel", sCircuit, sPanel, diXY[1], diXY[2]);  

  return iRes;  
}

//------------------------------------------------------------------------------------------------------------------------
/** unLHCCircuit_CRYO_getPanelDollarParameter
*/

int unLHCCircuit_CRYO_getPanelDollarParameter(const string sCircuit, const string sFile, const string sDollars, const string sDFB, dyn_string &dsDollars)
{
bool bFound;
int iRes, i, iLen, j, jLen;
string sValue;
dyn_string dsSplit, dsDollarsNeeded;
dyn_bool dbPattern;
  
  iRes=0;
  if(sCircuit!="" && sFile!="")
    {
    //What we have?
    dsSplit=strsplit(sDollars,"~");
    dynAppend(dsSplit, "$CIRCUIT:" + sCircuit);
        
    //What we need?
    dsDollarsNeeded=getDollarParamsFromPanel(sFile);
    iLen=dynlen(dsDollarsNeeded);
    for(i=1;i<=iLen;i++)
      {
      bFound=FALSE;
      dbPattern=patternMatch(dsDollarsNeeded[i]+"*", dsSplit);
      jLen=dynlen(dbPattern);
      for(j=1;j<=jLen && !bFound;j++)
        {
        if(dbPattern[j])
          {
          bFound=TRUE;
          sValue=dsSplit[j];
          }
        }
      
      if(!bFound) 
        {
        sValue=dsDollarsNeeded[i]+":";
        iRes--;
        DebugN("unLHCCircuit_CRYO_getPanelDollarParameter() - Circuit: " + sCircuit + " - DFB: " + sDFB + " - " + dsDollarsNeeded[i] + " not found!", sFile, sDollars);
        }
      
      dynAppend(dsDollars, sValue);        
      }
    }
  else
    DebugN("unLHCCircuit_CRYO_getPanelDollarParameter() - Invalid entries - Circuit: " + sCircuit + " - File: " + sFile);
    
  unGenericDpFunctions_debugN(DEBUG_ONLY_BIT0, sCircuit, "unLHCCircuit_CRYO_getPanelDollarParameter()", dsDollars);  
  
  return iRes;  
}

//------------------------------------------------------------------------------------------------------------------------
/** unLHCCircuit_CRYO_addCryoSymbol
*/

int unLHCCircuit_CRYO_addCryoSymbol(const string sCircuit, const string sInterlockType, const string sCircuitType,const string sCryoDollars)
{
int iRes, iRes_0, iRes_1, iRes_2, iRes_3;
string sPanel, sDFB;
dyn_string dsDollars, dsInfo;
dyn_int diXY;  

  //add notification report shortcut
  unNotify_addSymbol(LHC_CIRCUIT_NOTIFY_ADDRESS, 50, 4);
  dsInfo=unNotify_getApplicationInfo();
  unNotify_addInfo(dsInfo);
  sPanel="";
  
  //add CRYO devices
  if(strlen(sCryoDollars)!=0)
    {
    iRes_0=unLHCCircuit_CRYO_getDFB(sCryoDollars, sDFB);  
    iRes_1=unLHCCircuit_CRYO_getCryoPanel(sCircuit, sInterlockType, sCircuitType, sCryoDollars, sDFB, sPanel, diXY);  
    iRes_2=unLHCCircuit_CRYO_getPanelDollarParameter(sCircuit, sPanel, sCryoDollars, sDFB, dsDollars);
	if(sPanel!="")	iRes_3=addSymbol(myModuleName(), myPanelName(), sPanel, sCircuit+"_CRYO", dsDollars, diXY[1], diXY[2], 0, 1, 1);
	else iRes_3=-10;
    iRes=(iRes_1*10)+(iRes_2*100)+(iRes_3*1000);
    
    dynClear(dsInfo);
    dsInfo=makeDynString("Circuit: " + sCircuit,
                         "InterlockType: " + sInterlockType,
                         "CircuitType: " + sCircuitType + "\n",
                         "Cryo Dollars: " + sCryoDollars,
                         "DFB: " + sDFB,
                         "Panel: " + sPanel);
    unNotify_updateInfo(dsInfo);
    }
  else
    iRes=addSymbol(myModuleName(), myPanelName(), "vision/SYNOPTICS/Synoptic_CRYO_empty.pnl", sCircuit+"_CRYO", dsDollars, 450, 360, 0, 1, 1);      
      
  return iRes;  
}

//------------------------------------------------------------------------------------------------------------------------
/** unLHCCircuit_CRYO_getDFB
*/

int unLHCCircuit_CRYO_getDFB(const string sCryoDollars, string &sDFB)
{
dyn_string dsSplit;  
int i, iLen, iRes;
bool bFound;
  
  dsSplit=strsplit(sCryoDollars, "~");
  iLen=dynlen(dsSplit);
  for(i=1;i<=iLen && !bFound;i++)
    {
    if(patternMatch("$DFB_SS_*",dsSplit[i]))
      {
      bFound=TRUE;
      sDFB=substr(dsSplit[i], strpos(dsSplit[i], ":")+1);
      sDFB=substr(sDFB, 0, strpos(sDFB, "."));      
      }
    }
  
  return iRes;
}

//@}
